#ifndef _STRING_H
#define _STRING_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool CompareCSString(const char *sBuf1, const char *sBuf2);
bool CompareNCString(const char *sBuf1, const char *sBuf2);
bool IsLower(char cIn);
bool IsNumber(char cIn);
bool IsNumeric(char *sText);
bool IsUpper(char cIn);
bool IsWhiteSpace(char cChar);
bool ReverseString(char *sBuf, int iBufSz);
char * LCaseEx (char *sBuf, int iBufSz);
char * UCaseEx (char *sBuf, int iBufSz);
char **Split(char *sBuf, char *sSplitOn);
char **SplitEx(char *sBuf, int iBufSz, char **sArray, int *iOutItems, char *sSplitOn, int iSplitOnSz);
char *FormatInteger(char *sOut, const long lIn);
char *FormatiString(char *sOut, const char *sIn);
char *LCase (char *sBuf);
char *SimpleCipherString(char *sBuf, int iBufSz);
char *StringScan(const char *sInBuf, int iStartPos, int iLength);
char *UCase (char *sBuf);
char ToLower(char cIn);
char ToUpper(char cIn);
int AppendStrings(const char *sBuf1, const char *sBuf2, int iBuf1Sz, int iBuf2Sz, char *sOutBuf);
int CompareFlagedString(const char *sBuf, const char *sFlag);
int CopyString(char *sOutBuf, const char *sInBuf, int iInBufSz);
int GetFirstCharPos(char *sInBuf, int iInBufSz);
int GetFlagedValue(const char *sBuf, int iSkpLen, int iBufSz, char *sOutBuf);
int GetLastCharPos(char *sInBuf, int iInBufSz);
int InStr(const char *sSearchFor, const char *sInBuf);
int InStrEx(const char *sSearchFor, const char *sInBuf, const int iBufSz, const int iStartPos);
int InStrExx(const char *sSearchFor, int sSearchForSz, const char *sInBuf, const int iBufSz, const int iStartPos);
int Left(const char *sInBuf, char *sOutBuf, int iInLen, int iLeft);
int MidEx(const char *sInBuf, int iInBufSz, int iStartPos, int iRChars, char *sOutBuf);
int ReplaceCharacter(const char *sInBuf, char *sOutBuf, const char cReplace, const char cWith);
int ReplaceStrings (const char *sInBuf, const char *sReplace, const char *sWith, char *sOutBuf);
int Right(const char *sInBuf, char *sOutBuf, int iInLen, int iRight);
int StrCatEx(char *sOutBuf, const char *sInBuf, int iInBufSz, int iOutBufSz);
int StringScanEx(const char *sInBuf, int iStartPos, int iLength, char *sOutVal);
int UBound(char **sArray);
void FreeArray(char **sArray);
void FreeArrayEx(char **sArray, int iItems);

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
